org.apache.commons.io.filefilter

## Class SymbolicLinkFileFilter

- java.lang.Object
- - org.apache.commons.io.filefilter.AbstractFileFilter
  - - org.apache.commons.io.filefilter.SymbolicLinkFileFilter

- All Implemented Interfaces:
    FileFilter, FilenameFilter, Serializable, FileVisitor<Path>, PathMatcher, PathFilter, PathVisitor, IOFileFilter

      public class SymbolicLinkFileFilter
      extends AbstractFileFilter
      implements Serializable

  This filter accepts `File`s that are symbolic links.

  For example, here is how to print out a list of the real files within the current directory:

  ## Using Classic IO

       File dir = FileUtils.current();
       String[] files = dir.list(SymbolicLinkFileFilter.INSTANCE);
       for (String file : files) {
           System.out.println(file);
       }

  ## Using NIO

       final Path dir = PathUtils.current();
       final AccumulatorPathVisitor visitor = AccumulatorPathVisitor.withLongCounters(SymbolicLinkFileFilter.INSTANCE);
       //
       // Walk one directory
       Files.walkFileTree(dir, Collections.emptySet(), 1, visitor);
       System.out.println(visitor.getPathCounters());
       System.out.println(visitor.getFileList());
       //
       visitor.getPathCounters().reset();
       //
       // Walk directory tree
       Files.walkFileTree(dir, visitor);
       System.out.println(visitor.getPathCounters());
       System.out.println(visitor.getDirList());
       System.out.println(visitor.getFileList());

  ## Deprecating Serialization

  Serialization is deprecated and will be removed in 3.0.

  See Also:
    `FileFilterUtils.fileFileFilter()`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static SymbolicLinkFileFilter` | `INSTANCE` Singleton instance of file filter.

    - ### Fields inherited from interface org.apache.commons.io.filefilter.IOFileFilter

      `EMPTY_STRING_ARRAY`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SymbolicLinkFileFilter()` Restrictive constructor.
    `` | `SymbolicLinkFileFilter(FileVisitResult onAccept, FileVisitResult onReject)` Constructs a new instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `accept(File file)` Tests to see if the file is a symbolic link.
    `FileVisitResult` | `accept(Path path, BasicFileAttributes attributes)` Tests to see if the file is a symbolic link.
    `(package private) boolean` | `isSymbolicLink(Path filePath)` Delegates to `Files.isSymbolicLink(Path)` for testing.

    - ### Methods inherited from class org.apache.commons.io.filefilter.AbstractFileFilter

      `accept, append, append, get, handle, isDirectory, isFile, postVisitDirectory, preVisitDirectory, toDefaultFileVisitResult, toFileVisitResult, toString, visitFile, visitFileFailed`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.io.filefilter.IOFileFilter

      `and, matches, negate, or`

- - ### Field Detail

    - #### INSTANCE

          public static final SymbolicLinkFileFilter INSTANCE

      Singleton instance of file filter.

  - ### Constructor Detail

    - #### SymbolicLinkFileFilter

          protected SymbolicLinkFileFilter()

      Restrictive constructor.

    - #### SymbolicLinkFileFilter

          public SymbolicLinkFileFilter(FileVisitResult onAccept,
                                        FileVisitResult onReject)

      Constructs a new instance.
      Parameters:
        `onAccept` - What to do on acceptance.
        `onReject` - What to do on rejection.

  - ### Method Detail

    - #### accept

          public boolean accept(File file)

      Tests to see if the file is a symbolic link.
      Specified by:
        `accept` in interface `FileFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Overrides:
        `accept` in class `AbstractFileFilter`
      Parameters:
        `file` - the File to check
      Returns:
        true if the file exists and is a symbolic link to either another file or a directory, false otherwise.

    - #### accept

          public FileVisitResult accept(Path path,
                                        BasicFileAttributes attributes)

      Tests to see if the file is a symbolic link.
      Specified by:
        `accept` in interface `PathFilter`
      Specified by:
        `accept` in interface `IOFileFilter`
      Parameters:
        `path` - the File Path to check
        `attributes` - the path's basic attributes (may be null).
      Returns:
        `onAccept` from `SymbolicLinkFileFilter(FileVisitResult, FileVisitResult)` if the file exists and is a symbolic link to either another file or a directory; returns `onReject` otherwise.

    - #### isSymbolicLink

          boolean isSymbolicLink(Path filePath)

      Delegates to `Files.isSymbolicLink(Path)` for testing.

      Using package access for unit tests. To facilitate unit testing, all calls to test if the file is a symbolic should go through this method. (See the unit test for why.)

      Parameters:
        `filePath` - The filePath to test
      Returns:
        true if the file exists and is a symbolic link to either a file or directory, false otherwise.